#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int mine_count; /* n̐ */
int opened_cell_count; /* łɊJ}X̐ */

int *print_field; /* \p̔z */
int *mine_field; /* n̏ꏊp̔z */
int field_width, field_height; /* tB[h̍L */


#define UNOPEND		(-1)
#define MINE		(-2)

/* L[{[h͂֐ */
int get_number() {
	int ret;
	char buf[256];
	
	/* obt@I[o[t[Ȃ悤fgets𗘗p */
	fgets(buf, sizeof(buf), stdin);
	ret = atoi(buf);
	/* obt@NA */
	fflush(stdin);
	
	return ret;
}

/* _ȐlԂ֐ */
int random(int max) {
	return (int)((rand() / (RAND_MAX + 1.0)) * max);
}

void initialize() {
	int i, mine;
	
	/* _}CY */
	srand((unsigned int)time(NULL));
	
	/* [U[tB[h̐ݒ */
	printf("Ֆʂ͂̕Ă:");
	field_width = get_number();
	printf("Ֆʂ̍͂Ă:");
	field_height = get_number();
	do {
		printf("n̐͂Ă:");
		mine_count = get_number();
		/* n͕̐KtB[h̍Lȉ */
	} while(mine_count > field_width * field_height);
	
	/* z̊m */
	print_field = (int*)malloc(sizeof(int) * field_width * field_height);
	if(print_field == NULL) {
		exit(EXIT_FAILURE);
	}
	mine_field = (int*)malloc(sizeof(int) * field_width * field_height);
	if(mine_field == NULL) {
		exit(EXIT_FAILURE);
	}
	
	mine = mine_count;
	for(i = 0; i < field_width * field_height; i++) {
		print_field[i] = UNOPEND;
		/* ̏ꏊɒnuǂ𔻒肷 */
		if(random(field_width * field_height - i) < mine) {
			mine_field[i] = 1;
			mine--;
		} else {
			mine_field[i] = 0;
		}
	}
}

void show_field() {
	int x, y, c;
	for(y = 0; y < field_height; y++) {
		for(x = 0; x < field_width; x++) {
			c = print_field[x + y * field_width];
			switch(c) {
			case UNOPEND:
				printf("/");
				break;
			case MINE:
				printf("*");
				break;
			default:
				printf("%d", c);
				break;
			}
		}
		printf("\n");
	}
}

#define OUTRANGE_CHECK(x, y)		((x) < 0 || (x) >= field_width || (y) < 0 || (y) >= field_height)
int open_cell(int x, int y) {
	int dx, dy, count;
	if(OUTRANGE_CHECK(x, y)) {
		/* z̊OȂ΁Aɖ߂ */
		return 1;
	}
	if(mine_field[x + y * field_width] == 1) {
		/* cOIn𓥂ł܂ */
		print_field[x + y * field_width] = MINE;
		return 0;
	}
	if(print_field[x + y * field_width] != UNOPEND) {
		/* ̃}X͂łɊJĂ̂ŁAɖ߂ */
		return 1;
	}
	/* n̂ŁÃ}XJ */
	opened_cell_count++;
	
	count = 0;
	/* ̒n̐̊mF */
	for(dx = x - 1; dx <= x + 1; dx++) {
		for(dy = y - 1; dy <= y + 1; dy++) {
			if(OUTRANGE_CHECK(dx, dy)) {
				continue;
			}
			if(mine_field[dx + dy * field_width] == 1) {
				count++;
			}
		}
	}
	
	print_field[x + y * field_width] = count;
	
	if(count == 0) {
		/* ܂̒n̐[Ȃ΁Ã}XSI[v*/
		for(dx = x - 1; dx <= x + 1; dx++) {
			for(dy = y - 1; dy <= y + 1; dy++) {
				open_cell(dx, dy);
			}
		}
	}
	return 1;
}

int main(void) {
	int x, y;
	printf("}CXC[p[\n");
	
	initialize(); /* ܂f[^ */
	while(opened_cell_count < field_width * field_height - mine_count) {
		/* ܂S̃}XJĂȂ */
		show_field();
		
		do {
			printf("J}XxW͂Ă(1`%d):", field_width);
			x = get_number();
		} while(x < 1 || x > field_width);
		do {
			printf("J}XyW͂Ă(1`%d):", field_height);
			y = get_number();
		} while(y < 1 || y > field_height);
		
		if(!open_cell(x - 1, y - 1)) {
			/* Q[I[o[ */
			show_field();
			printf("Q[I[o[\n");
			return 0;
		}
	}
	
	show_field();
	printf("NA[\n");
	return 0;
}
